<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>35.1. posix — The most common POSIX system calls &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="35. Unix Specific Services" href="unix.html" />
    <link rel="next" title="35.2. pwd — The password database" href="pwd.html" />
    <link rel="prev" title="35. Unix Specific Services" href="unix.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pwd.html" title="35.2. pwd — The password database"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="unix.html" title="35. Unix Specific Services"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="unix.html" accesskey="U">35. Unix Specific Services</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-posix">
<span id="posix-the-most-common-posix-system-calls"></span><h1>35.1. <a class="reference internal" href="#module-posix" title="posix: The most common POSIX system calls (normally used via module os). (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">posix</span></code></a> &#8212; The most common POSIX system calls<a class="headerlink" href="#module-posix" title="Permalink to this headline">¶</a></h1>
<p>This module provides access to operating system functionality that is
standardized by the C Standard and the POSIX standard (a thinly disguised Unix
interface).</p>
<p id="index-0"><strong>Do not import this module directly.</strong>  Instead, import the module <a class="reference internal" href="os.html#module-os" title="os: Miscellaneous operating system interfaces."><code class="xref py py-mod docutils literal"><span class="pre">os</span></code></a>,
which provides a <em>portable</em> version of this interface.  On Unix, the <a class="reference internal" href="os.html#module-os" title="os: Miscellaneous operating system interfaces."><code class="xref py py-mod docutils literal"><span class="pre">os</span></code></a>
module provides a superset of the <a class="reference internal" href="#module-posix" title="posix: The most common POSIX system calls (normally used via module os). (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">posix</span></code></a> interface.  On non-Unix operating
systems the <a class="reference internal" href="#module-posix" title="posix: The most common POSIX system calls (normally used via module os). (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">posix</span></code></a> module is not available, but a subset is always
available through the <a class="reference internal" href="os.html#module-os" title="os: Miscellaneous operating system interfaces."><code class="xref py py-mod docutils literal"><span class="pre">os</span></code></a> interface.  Once <a class="reference internal" href="os.html#module-os" title="os: Miscellaneous operating system interfaces."><code class="xref py py-mod docutils literal"><span class="pre">os</span></code></a> is imported, there is
<em>no</em> performance penalty in using it instead of <a class="reference internal" href="#module-posix" title="posix: The most common POSIX system calls (normally used via module os). (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">posix</span></code></a>.  In addition,
<a class="reference internal" href="os.html#module-os" title="os: Miscellaneous operating system interfaces."><code class="xref py py-mod docutils literal"><span class="pre">os</span></code></a> provides some additional functionality, such as automatically calling
<a class="reference internal" href="os.html#os.putenv" title="os.putenv"><code class="xref py py-func docutils literal"><span class="pre">putenv()</span></code></a> when an entry in <code class="docutils literal"><span class="pre">os.environ</span></code> is changed.</p>
<p>Errors are reported as exceptions; the usual exceptions are given for type
errors, while errors reported by the system calls raise <a class="reference internal" href="exceptions.html#OSError" title="OSError"><code class="xref py py-exc docutils literal"><span class="pre">OSError</span></code></a>.</p>
<div class="section" id="large-file-support">
<span id="posix-large-files"></span><h2>35.1.1. Large File Support<a class="headerlink" href="#large-file-support" title="Permalink to this headline">¶</a></h2>
<p id="index-1">Several operating systems (including AIX, HP-UX, Irix and Solaris) provide
support for files that are larger than 2 GiB from a C programming model where
<code class="xref c c-type docutils literal"><span class="pre">int</span></code> and <code class="xref c c-type docutils literal"><span class="pre">long</span></code> are 32-bit values. This is typically accomplished
by defining the relevant size and offset types as 64-bit values. Such files are
sometimes referred to as <em class="dfn">large files</em>.</p>
<p>Large file support is enabled in Python when the size of an <code class="xref c c-type docutils literal"><span class="pre">off_t</span></code> is
larger than a <code class="xref c c-type docutils literal"><span class="pre">long</span></code> and the <code class="xref c c-type docutils literal"><span class="pre">long</span> <span class="pre">long</span></code> type is available and is
at least as large as an <code class="xref c c-type docutils literal"><span class="pre">off_t</span></code>.
It may be necessary to configure and compile Python with certain compiler flags
to enable this mode. For example, it is enabled by default with recent versions
of Irix, but with Solaris 2.6 and 2.7 you need to do something like:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="n">CFLAGS</span><span class="o">=</span><span class="s">&quot;`getconf LFS_CFLAGS`&quot;</span> <span class="n">OPT</span><span class="o">=</span><span class="s">&quot;-g -O2 $CFLAGS&quot;</span> \
        <span class="o">./</span><span class="n">configure</span>
</pre></div>
</div>
<p>On large-file-capable Linux systems, this might work:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="n">CFLAGS</span><span class="o">=</span><span class="s">&#39;-D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64&#39;</span> <span class="n">OPT</span><span class="o">=</span><span class="s">&quot;-g -O2 $CFLAGS&quot;</span> \
        <span class="o">./</span><span class="n">configure</span>
</pre></div>
</div>
</div>
<div class="section" id="notable-module-contents">
<span id="posix-contents"></span><h2>35.1.2. Notable Module Contents<a class="headerlink" href="#notable-module-contents" title="Permalink to this headline">¶</a></h2>
<p>In addition to many functions described in the <a class="reference internal" href="os.html#module-os" title="os: Miscellaneous operating system interfaces."><code class="xref py py-mod docutils literal"><span class="pre">os</span></code></a> module documentation,
<a class="reference internal" href="#module-posix" title="posix: The most common POSIX system calls (normally used via module os). (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">posix</span></code></a> defines the following data item:</p>
<dl class="data">
<dt id="posix.environ">
<code class="descclassname">posix.</code><code class="descname">environ</code><a class="headerlink" href="#posix.environ" title="Permalink to this definition">¶</a></dt>
<dd><p>A dictionary representing the string environment at the time the interpreter
was started. Keys and values are bytes on Unix and str on Windows. For
example, <code class="docutils literal"><span class="pre">environ[b'HOME']</span></code> (<code class="docutils literal"><span class="pre">environ['HOME']</span></code> on Windows) is the
pathname of your home directory, equivalent to <code class="docutils literal"><span class="pre">getenv(&quot;HOME&quot;)</span></code> in C.</p>
<p>Modifying this dictionary does not affect the string environment passed on by
<a class="reference internal" href="os.html#os.execv" title="os.execv"><code class="xref py py-func docutils literal"><span class="pre">execv()</span></code></a>, <a class="reference internal" href="os.html#os.popen" title="os.popen"><code class="xref py py-func docutils literal"><span class="pre">popen()</span></code></a> or <a class="reference internal" href="os.html#os.system" title="os.system"><code class="xref py py-func docutils literal"><span class="pre">system()</span></code></a>; if you need to
change the environment, pass <code class="docutils literal"><span class="pre">environ</span></code> to <a class="reference internal" href="os.html#os.execve" title="os.execve"><code class="xref py py-func docutils literal"><span class="pre">execve()</span></code></a> or add
variable assignments and export statements to the command string for
<a class="reference internal" href="os.html#os.system" title="os.system"><code class="xref py py-func docutils literal"><span class="pre">system()</span></code></a> or <a class="reference internal" href="os.html#os.popen" title="os.popen"><code class="xref py py-func docutils literal"><span class="pre">popen()</span></code></a>.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span>On Unix, keys and values are bytes.</p>
</div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The <a class="reference internal" href="os.html#module-os" title="os: Miscellaneous operating system interfaces."><code class="xref py py-mod docutils literal"><span class="pre">os</span></code></a> module provides an alternate implementation of <code class="docutils literal"><span class="pre">environ</span></code>
which updates the environment on modification. Note also that updating
<a class="reference internal" href="os.html#os.environ" title="os.environ"><code class="xref py py-data docutils literal"><span class="pre">os.environ</span></code></a> will render this dictionary obsolete. Use of the
<a class="reference internal" href="os.html#module-os" title="os: Miscellaneous operating system interfaces."><code class="xref py py-mod docutils literal"><span class="pre">os</span></code></a> module version of this is recommended over direct access to the
<a class="reference internal" href="#module-posix" title="posix: The most common POSIX system calls (normally used via module os). (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">posix</span></code></a> module.</p>
</div>
</dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">35.1. <code class="docutils literal"><span class="pre">posix</span></code> &#8212; The most common POSIX system calls</a><ul>
<li><a class="reference internal" href="#large-file-support">35.1.1. Large File Support</a></li>
<li><a class="reference internal" href="#notable-module-contents">35.1.2. Notable Module Contents</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="unix.html"
                        title="previous chapter">35. Unix Specific Services</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="pwd.html"
                        title="next chapter">35.2. <code class="docutils literal"><span class="pre">pwd</span></code> &#8212; The password database</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/posix.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pwd.html" title="35.2. pwd — The password database"
             >next</a> |</li>
        <li class="right" >
          <a href="unix.html" title="35. Unix Specific Services"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="unix.html" >35. Unix Specific Services</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>